
//	Preparations

#delimit ;

clear;
set more off;


//	Data

use rscfp1989_2010.dta;

gen finass_norm=(finass+intdivinc+kginc+wageinc+ssretinc+transfothinc)/(wageinc+ssretinc+transfothinc);

keep if lf==1;
keep if finass_norm>0;
keep if finass_norm<61.98485; // outliers corresponding to top 5% excluded

gen asset2931=finass_norm if AgeD2931==1;
gen asset3234=finass_norm if AgeD3234==1;
gen asset3537=finass_norm if AgeD3537==1;
gen asset3840=finass_norm if AgeD3840==1;
gen asset4143=finass_norm if AgeD4143==1;
gen asset4446=finass_norm if AgeD4446==1;
gen asset4749=finass_norm if AgeD4749==1;
gen asset5052=finass_norm if AgeD5052==1;
gen asset5355=finass_norm if AgeD5355==1;
gen asset5658=finass_norm if AgeD5658==1;
gen asset5961=finass_norm if AgeD5961==1;
gen asset6264=finass_norm if AgeD6264==1;
gen asset6567=finass_norm if AgeD6567==1;
gen asset6870=finass_norm if AgeD6870==1;
gen asset7173=finass_norm if AgeD7173==1;
gen asset7476=finass_norm if AgeD7476==1;


// Densities

kdensity asset2931, kernel(gaussian) name(asset2931, replace) n(1000) generate(x_asset2931 kd_asset2931);
kdensity asset3234, kernel(gaussian) name(asset3234, replace) n(1000) generate(x_asset3234 kd_asset3234);
kdensity asset3537, kernel(gaussian) name(asset3537, replace) n(1000) generate(x_asset3537 kd_asset3537);
kdensity asset3840, kernel(gaussian) name(asset3840, replace) n(1000) generate(x_asset3840 kd_asset3840);
kdensity asset4143, kernel(gaussian) name(asset4143, replace) n(1000) generate(x_asset4143 kd_asset4143);
kdensity asset4446, kernel(gaussian) name(asset4446, replace) n(1000) generate(x_asset4446 kd_asset4446);
kdensity asset4749, kernel(gaussian) name(asset4749, replace) n(1000) generate(x_asset4749 kd_asset4749);
kdensity asset5052, kernel(gaussian) name(asset5052, replace) n(1000) generate(x_asset5052 kd_asset5052);
kdensity asset5355, kernel(gaussian) name(asset5355, replace) n(1000) generate(x_asset5355 kd_asset5355);
kdensity asset5658, kernel(gaussian) name(asset5658, replace) n(1000) generate(x_asset5658 kd_asset5658);
kdensity asset5961, kernel(gaussian) name(asset5961, replace) n(1000) generate(x_asset5961 kd_asset5961);
kdensity asset6264, kernel(gaussian) name(asset6264, replace) n(1000) generate(x_asset6264 kd_asset6264);
kdensity asset6567, kernel(gaussian) name(asset6567, replace) n(1000) generate(x_asset6567 kd_asset6567);
kdensity asset6870, kernel(gaussian) name(asset6870, replace) n(1000) generate(x_asset6870 kd_asset6870);
kdensity asset7173, kernel(gaussian) name(asset7173, replace) n(1000) generate(x_asset7173 kd_asset7173);
kdensity asset7476, kernel(gaussian) name(asset7476, replace) n(1000) generate(x_asset7476 kd_asset7476);


// Save

outsheet 
x_asset2931 kd_asset2931 x_asset3234 kd_asset3234 x_asset3537 kd_asset3537 x_asset3840 kd_asset3840
x_asset4143 kd_asset4143 x_asset4446 kd_asset4446 x_asset4749 kd_asset4749 x_asset5052 kd_asset5052
x_asset5355 kd_asset5355 x_asset5658 kd_asset5658 x_asset5961 kd_asset5961 x_asset6264 kd_asset6264
x_asset6567 kd_asset6567 x_asset6870 kd_asset6870 x_asset7173 kd_asset7173 x_asset7476 kd_asset7476
using DensitiesSCF.dat, replace;


