
//	Preparations

#delimit ;

clear;
set more off;


//	Load data and calculate means of wealth

use rscfp1989_2010.dta;

gen finass_norm=(finass+intdivinc+kginc+wageinc+ssretinc+transfothinc)/(wageinc+ssretinc+transfothinc);

keep if lf==1;
keep if finass_norm>0;
keep if finass_norm<61.98485;


gen asset2931=finass_norm if AgeD2931==1;
gen asset3234=finass_norm if AgeD3234==1;
gen asset3537=finass_norm if AgeD3537==1;
gen asset3840=finass_norm if AgeD3840==1;
gen asset4143=finass_norm if AgeD4143==1;
gen asset4446=finass_norm if AgeD4446==1;
gen asset4749=finass_norm if AgeD4749==1;
gen asset5052=finass_norm if AgeD5052==1;
gen asset5355=finass_norm if AgeD5355==1;
gen asset5658=finass_norm if AgeD5658==1;
gen asset5961=finass_norm if AgeD5961==1;
gen asset6264=finass_norm if AgeD6264==1;
gen asset6567=finass_norm if AgeD6567==1;
gen asset6870=finass_norm if AgeD6870==1;
gen asset7173=finass_norm if AgeD7173==1;
gen asset7476=finass_norm if AgeD7476==1;

keep asset*;

egen mean_asset2931=mean(asset2931);
egen mean_asset3234=mean(asset3234);
egen mean_asset3537=mean(asset3537);
egen mean_asset3840=mean(asset3840);
egen mean_asset4143=mean(asset4143);
egen mean_asset4446=mean(asset4446);
egen mean_asset4749=mean(asset4749);
egen mean_asset5052=mean(asset5052);
egen mean_asset5355=mean(asset5355);
egen mean_asset5658=mean(asset5658);
egen mean_asset5961=mean(asset5961);
egen mean_asset6264=mean(asset6264);
egen mean_asset6567=mean(asset6567);
egen mean_asset6870=mean(asset6870);
egen mean_asset7173=mean(asset7173);
egen mean_asset7476=mean(asset7476);

drop asset*;
drop if _n>1;


// Save

outsheet using MeansSCF.dat, replace;
