

//	Preparations

#delimit ;

clear;
set more off;


//	Load and transform macro data

use MacroData.dta;

gen CPI2010=CPI[22];
replace StockPrices=StockPrices/CPI*CPI2010;
replace Dividends=Dividends/CPI*CPI2010;


//	Principal components

pca InterestRate1yr Yield10yrTreasury StockPriceGrowth DividendGrowth GDPgrowthAnn Unemployment TradeWeightedDollarGrowth CPI_Inflation HousePricegrowth, components(4);
predict pc1 pc2 pc3 pc4;
estat kmo; 
screeplot;


//	Drop years not contained in the SCF sample

keep if Year==1989 | Year==1992 | Year==1995 | Year==1998 | Year==2001 | Year==2004 | Year==2007 | Year==2010;


//	Save dataset

save MacroData2.dta, replace;
