

//	Preparations

#delimit ;

clear;
set more off;


//	Data and additional variables

use rscfp1989_2010.dta;
keep if InCohorts==1;

gen Time1995DP=Time1995-(2*Time1992-Time1989);
gen Time1998DP=Time1998-(3*Time1992-2*Time1989);
gen Time2001DP=Time2001-(4*Time1992-3*Time1989);
gen Time2004DP=Time2004-(5*Time1992-4*Time1989);
gen Time2007DP=Time2007-(6*Time1992-5*Time1989);

gen Trend=1;
replace Trend=2 if Year==1992;
replace Trend=3 if Year==1995;
replace Trend=4 if Year==1998;
replace Trend=5 if Year==2001;
replace Trend=6 if Year==2004;
replace Trend=7 if Year==2007;

egen sofinass_MeanStockholder=mean(sofinass) if Stockholder==1;

egen sofinass89=mean(sofinass) if Time1989==1;
egen sofinass92=mean(sofinass) if Time1992==1;
egen sofinass95=mean(sofinass) if Time1995==1;
egen sofinass98=mean(sofinass) if Time1998==1;
egen sofinass01=mean(sofinass) if Time2001==1;
egen sofinass04=mean(sofinass) if Time2004==1;
egen sofinass07=mean(sofinass) if Time2007==1;

gen sTrend=sofinass89;
replace sTrend=sofinass92 if Year==1992;
replace sTrend=sofinass95 if Year==1995;
replace sTrend=sofinass98 if Year==1998;
replace sTrend=sofinass01 if Year==2001;
replace sTrend=sofinass04 if Year==2004;
replace sTrend=sofinass07 if Year==2007;

replace sofinass=sofinass-sTrend;


//	Estimation

heckman sofinass
i.AgeD2628 i.AgeD2931 i.AgeD3234 i.AgeD3537 i.AgeD3840 i.AgeD4143 i.AgeD4446 i.AgeD4749 i.AgeD5052 i.AgeD5355 i.AgeD5658 i.AgeD5961 i.AgeD6264 i.AgeD6567 i.AgeD6870 i.AgeD7173 i.AgeD7476
Time1995DP Time1998DP Time2001DP Time2004DP Time2007DP
Cohort3436 Cohort3739 Cohort4042 Cohort4345 Cohort4648 Cohort4951 Cohort5254 Cohort5557 Cohort5860 Cohort6163
married race_black race_hispanic race_other educ_collegedipl occat2_manag occat2_notworking dbplant debt
if imp==1, noconst twostep
select(Stockholder=
i.AgeD2931 i.AgeD3234 i.AgeD3537 i.AgeD3840 i.AgeD4143 i.AgeD4446 i.AgeD4749 i.AgeD5052 i.AgeD5355 i.AgeD5658 i.AgeD5961 i.AgeD6264 i.AgeD6567 i.AgeD6870 i.AgeD7173 i.AgeD7476
Time1995DP Time1998DP Time2001DP Time2004DP Time2007DP
Cohort3436 Cohort3739 Cohort4042 Cohort4345 Cohort4648 Cohort4951 Cohort5254 Cohort5557 Cohort5860 Cohort6163
married race_black race_hispanic race_other educ_schooldipl educ_somecollege educ_collegedipl occat2_manag occat2_notworking dbplant debt Trend, noconst);

margins 1.AgeD2931 1.AgeD3234 1.AgeD3537 1.AgeD3840 1.AgeD4143 1.AgeD4446 1.AgeD4749 1.AgeD5052 1.AgeD5355 1.AgeD5658 1.AgeD5961 1.AgeD6264 1.AgeD6567 1.AgeD6870 1.AgeD7173 1.AgeD7476, predict(psel) noestimcheck;
matrix marg_part1=r(b)';

margins 1.AgeD2931 1.AgeD3234 1.AgeD3537 1.AgeD3840 1.AgeD4143 1.AgeD4446 1.AgeD4749 1.AgeD5052 1.AgeD5355 1.AgeD5658 1.AgeD5961 1.AgeD6264 1.AgeD6567 1.AgeD6870 1.AgeD7173 1.AgeD7476, noestimcheck;
matrix marg_cond1=r(b)';


heckman sofinass
i.AgeD2628 i.AgeD2931 i.AgeD3234 i.AgeD3537 i.AgeD3840 i.AgeD4143 i.AgeD4446 i.AgeD4749 i.AgeD5052 i.AgeD5355 i.AgeD5658 i.AgeD5961 i.AgeD6264 i.AgeD6567 i.AgeD6870 i.AgeD7173 i.AgeD7476
Time1995DP Time1998DP Time2001DP Time2004DP Time2007DP
Cohort3436 Cohort3739 Cohort4042 Cohort4345 Cohort4648 Cohort4951 Cohort5254 Cohort5557 Cohort5860 Cohort6163
married race_black race_hispanic race_other educ_collegedipl occat2_manag occat2_notworking dbplant debt
if imp==2, noconst twostep
select(Stockholder=
i.AgeD2931 i.AgeD3234 i.AgeD3537 i.AgeD3840 i.AgeD4143 i.AgeD4446 i.AgeD4749 i.AgeD5052 i.AgeD5355 i.AgeD5658 i.AgeD5961 i.AgeD6264 i.AgeD6567 i.AgeD6870 i.AgeD7173 i.AgeD7476
Time1995DP Time1998DP Time2001DP Time2004DP Time2007DP
Cohort3436 Cohort3739 Cohort4042 Cohort4345 Cohort4648 Cohort4951 Cohort5254 Cohort5557 Cohort5860 Cohort6163
married race_black race_hispanic race_other educ_schooldipl educ_somecollege educ_collegedipl occat2_manag occat2_notworking dbplant debt Trend, noconst);

margins 1.AgeD2931 1.AgeD3234 1.AgeD3537 1.AgeD3840 1.AgeD4143 1.AgeD4446 1.AgeD4749 1.AgeD5052 1.AgeD5355 1.AgeD5658 1.AgeD5961 1.AgeD6264 1.AgeD6567 1.AgeD6870 1.AgeD7173 1.AgeD7476, predict(psel) noestimcheck;
matrix marg_part2=r(b)';

margins 1.AgeD2931 1.AgeD3234 1.AgeD3537 1.AgeD3840 1.AgeD4143 1.AgeD4446 1.AgeD4749 1.AgeD5052 1.AgeD5355 1.AgeD5658 1.AgeD5961 1.AgeD6264 1.AgeD6567 1.AgeD6870 1.AgeD7173 1.AgeD7476, noestimcheck;
matrix marg_cond2=r(b)';


heckman sofinass
i.AgeD2628 i.AgeD2931 i.AgeD3234 i.AgeD3537 i.AgeD3840 i.AgeD4143 i.AgeD4446 i.AgeD4749 i.AgeD5052 i.AgeD5355 i.AgeD5658 i.AgeD5961 i.AgeD6264 i.AgeD6567 i.AgeD6870 i.AgeD7173 i.AgeD7476
Time1995DP Time1998DP Time2001DP Time2004DP Time2007DP
Cohort3436 Cohort3739 Cohort4042 Cohort4345 Cohort4648 Cohort4951 Cohort5254 Cohort5557 Cohort5860 Cohort6163
married race_black race_hispanic race_other educ_collegedipl occat2_manag occat2_notworking dbplant debt
if imp==3, noconst twostep
select(Stockholder=
i.AgeD2931 i.AgeD3234 i.AgeD3537 i.AgeD3840 i.AgeD4143 i.AgeD4446 i.AgeD4749 i.AgeD5052 i.AgeD5355 i.AgeD5658 i.AgeD5961 i.AgeD6264 i.AgeD6567 i.AgeD6870 i.AgeD7173 i.AgeD7476
Time1995DP Time1998DP Time2001DP Time2004DP Time2007DP
Cohort3436 Cohort3739 Cohort4042 Cohort4345 Cohort4648 Cohort4951 Cohort5254 Cohort5557 Cohort5860 Cohort6163
married race_black race_hispanic race_other educ_schooldipl educ_somecollege educ_collegedipl occat2_manag occat2_notworking dbplant debt Trend, noconst);

margins 1.AgeD2931 1.AgeD3234 1.AgeD3537 1.AgeD3840 1.AgeD4143 1.AgeD4446 1.AgeD4749 1.AgeD5052 1.AgeD5355 1.AgeD5658 1.AgeD5961 1.AgeD6264 1.AgeD6567 1.AgeD6870 1.AgeD7173 1.AgeD7476, predict(psel) noestimcheck;
matrix marg_part3=r(b)';

margins 1.AgeD2931 1.AgeD3234 1.AgeD3537 1.AgeD3840 1.AgeD4143 1.AgeD4446 1.AgeD4749 1.AgeD5052 1.AgeD5355 1.AgeD5658 1.AgeD5961 1.AgeD6264 1.AgeD6567 1.AgeD6870 1.AgeD7173 1.AgeD7476, noestimcheck;
matrix marg_cond3=r(b)';


heckman sofinass
i.AgeD2628 i.AgeD2931 i.AgeD3234 i.AgeD3537 i.AgeD3840 i.AgeD4143 i.AgeD4446 i.AgeD4749 i.AgeD5052 i.AgeD5355 i.AgeD5658 i.AgeD5961 i.AgeD6264 i.AgeD6567 i.AgeD6870 i.AgeD7173 i.AgeD7476
Time1995DP Time1998DP Time2001DP Time2004DP Time2007DP
Cohort3436 Cohort3739 Cohort4042 Cohort4345 Cohort4648 Cohort4951 Cohort5254 Cohort5557 Cohort5860 Cohort6163
married race_black race_hispanic race_other educ_collegedipl occat2_manag occat2_notworking dbplant debt
if imp==4, noconst twostep
select(Stockholder=
i.AgeD2931 i.AgeD3234 i.AgeD3537 i.AgeD3840 i.AgeD4143 i.AgeD4446 i.AgeD4749 i.AgeD5052 i.AgeD5355 i.AgeD5658 i.AgeD5961 i.AgeD6264 i.AgeD6567 i.AgeD6870 i.AgeD7173 i.AgeD7476
Time1995DP Time1998DP Time2001DP Time2004DP Time2007DP
Cohort3436 Cohort3739 Cohort4042 Cohort4345 Cohort4648 Cohort4951 Cohort5254 Cohort5557 Cohort5860 Cohort6163
married race_black race_hispanic race_other educ_schooldipl educ_somecollege educ_collegedipl occat2_manag occat2_notworking dbplant debt Trend, noconst);

margins 1.AgeD2931 1.AgeD3234 1.AgeD3537 1.AgeD3840 1.AgeD4143 1.AgeD4446 1.AgeD4749 1.AgeD5052 1.AgeD5355 1.AgeD5658 1.AgeD5961 1.AgeD6264 1.AgeD6567 1.AgeD6870 1.AgeD7173 1.AgeD7476, predict(psel) noestimcheck;
matrix marg_part4=r(b)';

margins 1.AgeD2931 1.AgeD3234 1.AgeD3537 1.AgeD3840 1.AgeD4143 1.AgeD4446 1.AgeD4749 1.AgeD5052 1.AgeD5355 1.AgeD5658 1.AgeD5961 1.AgeD6264 1.AgeD6567 1.AgeD6870 1.AgeD7173 1.AgeD7476, noestimcheck;
matrix marg_cond4=r(b)';


heckman sofinass
i.AgeD2628 i.AgeD2931 i.AgeD3234 i.AgeD3537 i.AgeD3840 i.AgeD4143 i.AgeD4446 i.AgeD4749 i.AgeD5052 i.AgeD5355 i.AgeD5658 i.AgeD5961 i.AgeD6264 i.AgeD6567 i.AgeD6870 i.AgeD7173 i.AgeD7476
Time1995DP Time1998DP Time2001DP Time2004DP Time2007DP
Cohort3436 Cohort3739 Cohort4042 Cohort4345 Cohort4648 Cohort4951 Cohort5254 Cohort5557 Cohort5860 Cohort6163
married race_black race_hispanic race_other educ_collegedipl occat2_manag occat2_notworking dbplant debt
if imp==5, noconst twostep
select(Stockholder=
i.AgeD2931 i.AgeD3234 i.AgeD3537 i.AgeD3840 i.AgeD4143 i.AgeD4446 i.AgeD4749 i.AgeD5052 i.AgeD5355 i.AgeD5658 i.AgeD5961 i.AgeD6264 i.AgeD6567 i.AgeD6870 i.AgeD7173 i.AgeD7476
Time1995DP Time1998DP Time2001DP Time2004DP Time2007DP
Cohort3436 Cohort3739 Cohort4042 Cohort4345 Cohort4648 Cohort4951 Cohort5254 Cohort5557 Cohort5860 Cohort6163
married race_black race_hispanic race_other educ_schooldipl educ_somecollege educ_collegedipl occat2_manag occat2_notworking dbplant debt Trend, noconst);

margins 1.AgeD2931 1.AgeD3234 1.AgeD3537 1.AgeD3840 1.AgeD4143 1.AgeD4446 1.AgeD4749 1.AgeD5052 1.AgeD5355 1.AgeD5658 1.AgeD5961 1.AgeD6264 1.AgeD6567 1.AgeD6870 1.AgeD7173 1.AgeD7476, predict(psel) noestimcheck;
matrix marg_part5=r(b)';

margins 1.AgeD2931 1.AgeD3234 1.AgeD3537 1.AgeD3840 1.AgeD4143 1.AgeD4446 1.AgeD4749 1.AgeD5052 1.AgeD5355 1.AgeD5658 1.AgeD5961 1.AgeD6264 1.AgeD6567 1.AgeD6870 1.AgeD7173 1.AgeD7476, noestimcheck;
matrix marg_cond5=r(b)';


//	Construct final estimates and export

matrix marg_part=(marg_part1+marg_part2+marg_part3+marg_part4+marg_part5)/5;
matrix marg_cond=(marg_cond1+marg_cond2+marg_cond3+marg_cond4+marg_cond5)/5;
matrix list marg_part; 
matrix list marg_cond;
keep sofinass_MeanStockholder;
replace sofinass_MeanStockholder=. if _n>16;
svmat marg_part;
rename marg_part1 marg_part;
svmat marg_cond;
rename marg_cond1 marg_cond;
outsheet marg_part marg_cond sofinass_MeanStockholder using S_DP.dat, replace;

