
clear;
clc;


%% Load Simulations

load Model_2_Simulation.mat
load Model_3_Exp1.mat
load Model_4_Exp2.mat


%% Figure - Policy Functions


figure('PaperPosition',[-2 12 25 14])

subplot(2,2,1)
hold on;
plot(27:80,part_mean,'-k','linewidth',1)
plot(27:80,part_mean_exp_rq,'--r','linewidth',1)
plot(27:80,part_mean_exp_rqrs,'-.b','linewidth',1)
line([44 44],[0 1],'Color','black','LineStyle','--','LineWidth',1.2)
line([50 50],[0 1],'Color','black','LineStyle','--','LineWidth',1.2)
hold off;
axis([41 62 0.45 1])
xticks([45 50 55 60])
xlabel('Age','FontSize',11,'Interpreter','latex')
ylabel('Participation','FontSize',11,'Interpreter','latex')
legend({'Baseline','Only shock to $r_q$','Shock to $r_q$ and $r_s$'},'FontSize',10,'Interpreter','latex','Location','southeast')
box on;

subplot(2,2,2)
hold on;
plot(27:80,q_share_condpart_mean,'-k','linewidth',1)
plot(27:80,q_share_condpart_mean_exp_rq,'--r','linewidth',1)
plot(27:80,q_share_condpart_mean_exp_rqrs,'-.b','linewidth',1)
line([44 44],[0 1],'Color','black','LineStyle','--','LineWidth',1.2)
line([50 50],[0 1],'Color','black','LineStyle','--','LineWidth',1.2)
hold off;
axis([41 62 0.02 0.3])
xticks([45 50 55 60])
xlabel('Age','FontSize',11,'Interpreter','latex')
ylabel('Conditional long-term debt share','FontSize',11,'Interpreter','latex')
box on;

subplot(2,2,3)
hold on;
plot(27:80,b_share_condpart_mean,'-k','linewidth',1)
plot(27:80,b_share_condpart_mean_exp_rq,'--r','linewidth',1)
plot(27:80,b_share_condpart_mean_exp_rqrs,'-.b','linewidth',1)
line([44 44],[0 1],'Color','black','LineStyle','--','LineWidth',1.2)
line([50 50],[0 1],'Color','black','LineStyle','--','LineWidth',1.2)
hold off;
axis([41 62 0 0.006])
xticks([45 50 55 60])
xlabel('Age','FontSize',11,'Interpreter','latex')
ylabel('Conditional cash share','FontSize',11,'Interpreter','latex')
box on;

subplot(2,2,4)
hold on;
plot(27:80,s_share_condpart_mean,'-k','linewidth',1)
plot(27:80,s_share_condpart_mean_exp_rq,'--r','linewidth',1)
plot(27:80,s_share_condpart_mean_exp_rqrs,'-.b','linewidth',1)
line([44 44],[0 1],'Color','black','LineStyle','--','LineWidth',1.2)
line([50 50],[0 1],'Color','black','LineStyle','--','LineWidth',1.2)
hold off;
axis([41 62 0.7 0.98])
xticks([45 50 55 60])
xlabel('Age','FontSize',11,'Interpreter','latex')
ylabel('Conditional stock share','FontSize',11,'Interpreter','latex')
box on;

print('Fig_11_exp','-dpdf')
