
clear;
clc;

%% Import Data


% Long-term debt

Q_res3439_data=importdata('Q_res3439.dat');
Q_res3439_partprob=Q_res3439_data.data(:,1);
Q_res3439_condshare=Q_res3439_data.data(:,2);

Q_res4651_data=importdata('Q_res4651.dat');
Q_res4651_partprob=Q_res4651_data.data(:,1);
Q_res4651_condshare=Q_res4651_data.data(:,2);

Q_DP_data=importdata('Q_DP.dat');
Q_DP_partprob=Q_DP_data.data(:,1);
Q_DP_condshare=Q_DP_data.data(:,2)+max(Q_DP_data.data(:,3));

Q_PCA_data=importdata('Q_PCA.dat');
Q_PCA_partprob=Q_PCA_data.data(:,1);
Q_PCA_condshare=Q_PCA_data.data(:,2)+max(Q_PCA_data.data(:,3));


% Stocks

S_res3439_data=importdata('S_res3439.dat');
S_res3439_partprob=S_res3439_data.data(:,1);
S_res3439_condshare=S_res3439_data.data(:,2);

S_res4651_data=importdata('S_res4651.dat');
S_res4651_partprob=S_res4651_data.data(:,1);
S_res4651_condshare=S_res4651_data.data(:,2);

S_DP_data=importdata('S_DP.dat');
S_DP_partprob=S_DP_data.data(:,1);
S_DP_condshare=S_DP_data.data(:,2)+max(S_DP_data.data(:,3));

S_PCA_data=importdata('S_PCA.dat');
S_PCA_partprob=S_PCA_data.data(:,1);
S_PCA_condshare=S_PCA_data.data(:,2)+max(S_PCA_data.data(:,3));


%% Figure


set(figure,'defaultAxesColorOrder',[0 0 0 ; 0 0 0]);

subplot(2,2,1)
hold on;
plot(Q_res3439_partprob(1:15),'.:b')
plot(Q_res4651_partprob(1:15),'x:g')
plot(Q_DP_partprob(1:15),'+-r')
plot(Q_PCA_partprob(1:15),'*-c')
axis([0 16 0.55 0.9])
xticks([2 6 10 14])
xticklabels({'32-34','44-46','56-58','68-70'})
yticks([0.6 0.7 0.8 0.9])
xlabel('Age group','FontSize',11,'Interpreter','latex')
ylabel({'Participation probability','(Long-term gov. debt)'},'FontSize',11,'Interpreter','latex')
title('a)','FontSize',11,'Interpreter','latex')
legend({'Cohort restriction ''34-''39','Cohort restriction ''46-''51','Deaton-Paxson','Principal Components'},'FontSize',11,'Interpreter','latex','Location','southoutside','Orientation','horizontal','Box','off')
hold off;
box on;

subplot(2,2,2)
hold on;
plot(Q_res3439_condshare(1:15),'.:b')
plot(Q_res4651_condshare(1:15),'x:g')
axis([0 16 0.11 0.29])
yticks([0.14 0.18 0.22 0.26])
ylabel({'Portfolio share','(Long-term gov. debt)'},'FontSize',11,'Interpreter','latex')
plot(Q_DP_condshare(1:15),'+-r')
plot(Q_PCA_condshare(1:15),'*-c')
xticks([2 6 10 14])
xticklabels({'32-34','44-46','56-58','68-70'})
xlabel('Age group','FontSize',11,'Interpreter','latex')
title('b)','FontSize',11,'Interpreter','latex')
hold off;
box on;

subplot(2,2,3)
hold on;
plot(S_res3439_partprob(1:15),'.:b')
plot(S_res4651_partprob(1:15),'x:g')
plot(S_DP_partprob(1:15),'+-r')
plot(S_PCA_partprob(1:15),'*-c')
axis([0 16 0.55 0.9])
xticks([2 6 10 14])
xticklabels({'32-34','44-46','56-58','68-70'})
yticks([0.6 0.7 0.8 0.9])
xlabel('Age group','FontSize',11,'Interpreter','latex')
ylabel({'Participation probability','(Stocks)'},'FontSize',11,'Interpreter','latex')
title('c)','FontSize',11,'Interpreter','latex')
hold off;
box on;

subplot(2,2,4)
hold on;
plot(S_res3439_condshare(1:15),'.:b')
plot(S_res4651_condshare(1:15),'x:g')
axis([0 16 0.45 0.85])
yticks([0.5 0.6 0.7 0.8])
ylabel({'Portfolio share','(Stocks)'},'FontSize',11,'Interpreter','latex')
plot(S_DP_condshare(1:15),'+-r')
plot(S_PCA_condshare(1:15),'*-c')
xticks([2 6 10 14])
xticklabels({'32-34','44-46','56-58','68-70'})
xlabel('Age group','FontSize',11,'Interpreter','latex')
title('d)','FontSize',11,'Interpreter','latex')
hold off;
box on;

