
clear;
clc;

global x_grid z_grid x_n z_n b_max q_max part bprime bprime_n bprime_p qprime qprime_n qprime_p sprime sprime_p

%% Load Model Solution

load Model_1_PolFun.mat


%% Policy Functions

age=30;
z=1;        % coordinate of z-holdings on z_grid
Rq_state=1; % 1 for low, 2 for high
Pol_Fun_30_Rqlow=Prep_Fun(age,z,Rq_state);

age=30;
z=1;        % coordinate of z-holdings on z_grid
Rq_state=2; % 1 for low, 2 for high
Pol_Fun_30_Rqhigh=Prep_Fun(age,z,Rq_state);

age=40;
z=1;        % coordinate of z-holdings on z_grid
Rq_state=1; % 1 for low, 2 for high
Pol_Fun_40_Rqlow=Prep_Fun(age,z,Rq_state);

age=40;
z=1;        % coordinate of z-holdings on z_grid
Rq_state=2; % 1 for low, 2 for high
Pol_Fun_40_Rqhigh=Prep_Fun(age,z,Rq_state);

age=50;
z=1;        % coordinate of z-holdings on z_grid
Rq_state=1; % 1 for low, 2 for high
Pol_Fun_50_Rqlow=Prep_Fun(age,z,Rq_state);

age=50;
z=1;        % coordinate of z-holdings on z_grid
Rq_state=2; % 1 for low, 2 for high
Pol_Fun_50_Rqhigh=Prep_Fun(age,z,Rq_state);

age=60;
z=1;        % coordinate of z-holdings on z_grid
Rq_state=1; % 1 for low, 2 for high
Pol_Fun_60_Rqlow=Prep_Fun(age,z,Rq_state);

age=60;
z=1;        % coordinate of z-holdings on z_grid
Rq_state=2; % 1 for low, 2 for high
Pol_Fun_60_Rqhigh=Prep_Fun(age,z,Rq_state);

age=70;
z=1;        % coordinate of z-holdings on z_grid
Rq_state=1; % 1 for low, 2 for high
Pol_Fun_70_Rqlow=Prep_Fun(age,z,Rq_state);

age=70;
z=1;        % coordinate of z-holdings on z_grid
Rq_state=2; % 1 for low, 2 for high
Pol_Fun_70_Rqhigh=Prep_Fun(age,z,Rq_state);


%% Figure

figure('PaperPosition',[-1 1 24 29])

subplot(5,2,1)
plot([0;x_grid],[0;x_grid],':k')
hold on;
plot(x_grid,Pol_Fun_30_Rqlow(:,1),'-.','linewidth',1,'color',[0.5,0.65,0.4])
plot(x_grid,Pol_Fun_30_Rqlow(:,2),'-r','linewidth',1)
plot(x_grid,Pol_Fun_30_Rqlow(:,3),'--b','linewidth',1)
hold off;
axis([0 7.9 0 7.9])
title('$r_q$ in low state','FontSize',11,'Interpreter','latex')
xlabel('$x$','FontSize',11,'Interpreter','latex')
ylabel('Age 30','FontSize',11,'Interpreter','latex')
legend({'$45^{\circ}$-line','$b$','$q$','$s$'},'FontSize',9,'Interpreter','latex','Location','northwest','box','off')

subplot(5,2,2)
plot([0;x_grid],[0;x_grid],':k')
hold on;
plot(x_grid,Pol_Fun_30_Rqhigh(:,1),'-.','linewidth',1,'color',[0.5,0.65,0.4])
plot(x_grid,Pol_Fun_30_Rqhigh(:,2),'-r','linewidth',1)
plot(x_grid,Pol_Fun_30_Rqhigh(:,3),'--b','linewidth',1)
hold off;
axis([0 7.9 0 7.9])
title('$r_q$ in high state','FontSize',11,'Interpreter','latex')
xlabel('$x$','FontSize',11,'Interpreter','latex')
ylabel('Age 30','FontSize',11,'Interpreter','latex')

subplot(5,2,3)
plot([0;x_grid],[0;x_grid],':k')
hold on;
plot(x_grid,Pol_Fun_40_Rqlow(:,1),'-.','linewidth',1,'color',[0.5,0.65,0.4])
plot(x_grid,Pol_Fun_40_Rqlow(:,2),'-r','linewidth',1)
plot(x_grid,Pol_Fun_40_Rqlow(:,3),'--b','linewidth',1)
hold off;
axis([0 7.9 0 7.9])
xlabel('$x$','FontSize',11,'Interpreter','latex')
ylabel('Age 40','FontSize',11,'Interpreter','latex')
    
subplot(5,2,4)
plot([0;x_grid],[0;x_grid],':k')
hold on;
plot(x_grid,Pol_Fun_40_Rqhigh(:,1),'-.','linewidth',1,'color',[0.5,0.65,0.4])
plot(x_grid,Pol_Fun_40_Rqhigh(:,2),'-r','linewidth',1)
plot(x_grid,Pol_Fun_40_Rqhigh(:,3),'--b','linewidth',1)
hold off;
axis([0 7.9 0 7.9])
xlabel('$x$','FontSize',11,'Interpreter','latex')
ylabel('Age 40','FontSize',11,'Interpreter','latex')

subplot(5,2,5)
plot([0;x_grid],[0;x_grid],':k')
hold on;
plot(x_grid,Pol_Fun_50_Rqlow(:,1),'-.','linewidth',1,'color',[0.5,0.65,0.4])
plot(x_grid,Pol_Fun_50_Rqlow(:,2),'-r','linewidth',1)
plot(x_grid,Pol_Fun_50_Rqlow(:,3),'--b','linewidth',1)
hold off;
axis([0 7.9 0 7.9])
xlabel('$x$','FontSize',11,'Interpreter','latex')
ylabel('Age 50','FontSize',11,'Interpreter','latex')
   
subplot(5,2,6)
plot([0;x_grid],[0;x_grid],':k')
hold on;
plot(x_grid,Pol_Fun_50_Rqhigh(:,1),'-.','linewidth',1,'color',[0.5,0.65,0.4])
plot(x_grid,Pol_Fun_50_Rqhigh(:,2),'-r','linewidth',1)
plot(x_grid,Pol_Fun_50_Rqhigh(:,3),'--b','linewidth',1)
hold off;
axis([0 7.9 0 7.9])
xlabel('$x$','FontSize',11,'Interpreter','latex')
ylabel('Age 50','FontSize',11,'Interpreter','latex')

subplot(5,2,7)
plot([0;x_grid],[0;x_grid],':k')
hold on;
plot(x_grid,Pol_Fun_60_Rqlow(:,1),'-.','linewidth',1,'color',[0.5,0.65,0.4])
plot(x_grid,Pol_Fun_60_Rqlow(:,2),'-r','linewidth',1)
plot(x_grid,Pol_Fun_60_Rqlow(:,3),'--b','linewidth',1)
hold off;
axis([0 7.9 0 7.9])
xlabel('$x$','FontSize',11,'Interpreter','latex')
ylabel('Age 60','FontSize',11,'Interpreter','latex')
   
subplot(5,2,8)
plot([0;x_grid],[0;x_grid],':k')
hold on;
plot(x_grid,Pol_Fun_60_Rqhigh(:,1),'-.','linewidth',1,'color',[0.5,0.65,0.4])
plot(x_grid,Pol_Fun_60_Rqhigh(:,2),'-r','linewidth',1)
plot(x_grid,Pol_Fun_60_Rqhigh(:,3),'--b','linewidth',1)
hold off;
axis([0 7.9 0 7.9])
xlabel('$x$','FontSize',11,'Interpreter','latex')
ylabel('Age 60','FontSize',11,'Interpreter','latex')

subplot(5,2,9)
plot([0;x_grid],[0;x_grid],':k')
hold on;
plot(x_grid,Pol_Fun_70_Rqlow(:,1),'-.','linewidth',1,'color',[0.5,0.65,0.4])
plot(x_grid,Pol_Fun_70_Rqlow(:,2),'-r','linewidth',1)
plot(x_grid,Pol_Fun_70_Rqlow(:,3),'--b','linewidth',1)
hold off;
axis([0 7.9 0 7.9])
xlabel('$x$','FontSize',11,'Interpreter','latex')
ylabel('Age 70','FontSize',11,'Interpreter','latex')
    
subplot(5,2,10)
plot([0;x_grid],[0;x_grid],':k')
hold on;
plot(x_grid,Pol_Fun_70_Rqhigh(:,1),'-.','linewidth',1,'color',[0.5,0.65,0.4])
plot(x_grid,Pol_Fun_70_Rqhigh(:,2),'-r','linewidth',1)
plot(x_grid,Pol_Fun_70_Rqhigh(:,3),'--b','linewidth',1)
hold off;
axis([0 7.9 0 7.9])
xlabel('$x$','FontSize',11,'Interpreter','latex')
ylabel('Age 70','FontSize',11,'Interpreter','latex')


print('Fig_5_PolFun','-dpdf')
