
clear;
clc;

global x_grid z_grid x_n z_n b_max q_max part bprime bprime_n bprime_p qprime qprime_n qprime_p sprime sprime_p

%% Load Model Solution

load Model_1_PolFun.mat


%% Policy Functions

age=60;
z=1;        % coordinate of z-holdings on z_grid
Rq_state=1; % 1 for low, 2 for high
Pol_Fun_45_Rqlow_zl=Prep_Fun(age,z,Rq_state);


age=60;
z=floor((z_n-5)/2);        % coordinate of z-holdings on z_grid
Rq_state=1; % 1 for low, 2 for high
Pol_Fun_45_Rqlow_zi=Prep_Fun(age,z,Rq_state);


age=60;
z=z_n-5;        % coordinate of z-holdings on z_grid
Rq_state=1; % 1 for low, 2 for high
Pol_Fun_45_Rqlow_zh=Prep_Fun(age,z,Rq_state);



%% Figure

figure('PaperPosition',[-2.2 15 25.2 5.5])

subplot(1,3,1)
plot([0;x_grid],[0;x_grid],':k')
hold on;
plot(x_grid,Pol_Fun_45_Rqlow_zl(:,1),'--','linewidth',1,'color',[0,0,0.5])
plot(x_grid,Pol_Fun_45_Rqlow_zi(:,1),'-.','linewidth',1,'color',[0.7,0,0.7])
plot(x_grid,Pol_Fun_45_Rqlow_zh(:,1),'--','linewidth',1,'color',[0.9,0.45,0])
hold off;
axis([0 5.9 0 5.9])
xticks([0 2 4 6])
yticks([0 2 4 6])
xlabel('$x$','FontSize',11,'Interpreter','latex')
ylabel('Safe asset','FontSize',11,'Interpreter','latex')
legend({'45-degree line','$z=0$','intermediate $z$','high $z$'},'FontSize',10,'Interpreter','latex','Location','northwest')
    
subplot(1,3,2)
plot([0;x_grid],[0;x_grid],':k')
hold on;
plot(x_grid,Pol_Fun_45_Rqlow_zl(:,2),'--','linewidth',1,'color',[0,0,0.5])
plot(x_grid,Pol_Fun_45_Rqlow_zi(:,2),'-.','linewidth',1,'color',[0.7,0,0.7])
plot(x_grid,Pol_Fun_45_Rqlow_zh(:,2),'--','linewidth',1,'color',[0.9,0.45,0])
hold off;
axis([0 6 0 6])
xticks([0 2 4])
yticks([0 2 4])
xlabel('$x$','FontSize',11,'Interpreter','latex')
ylabel('Long-term gov. debt','FontSize',11,'Interpreter','latex')

subplot(1,3,3)
plot([0;x_grid],[0;x_grid],':k')
hold on;
plot(x_grid,Pol_Fun_45_Rqlow_zl(:,3),'--','linewidth',1,'color',[0,0,0.5])
plot(x_grid,Pol_Fun_45_Rqlow_zi(:,3),'-.','linewidth',1,'color',[0.7,0,0.7])
plot(x_grid,Pol_Fun_45_Rqlow_zh(:,3),'--','linewidth',1,'color',[0.9,0.45,0])
hold off;
axis([0 4 0 4])
xticks([0 2 4])
yticks([0 2 4])
xlabel('$x$','FontSize',11,'Interpreter','latex')
ylabel('Stocks','FontSize',11,'Interpreter','latex')


print('Fig_6_PolFunz','-dpdf')
