
clear;
clc;


%% Model

load Model_2_Simulation.mat

wealth_t=x_t+z_t;

% Densities

[wealth_distr3840,xixi3840,bw3840]=ksdensity((wealth_t(:,12)+wealth_t(:,13)+wealth_t(:,14))/3);
[wealth_distr4143,xixi4143,bw4143]=ksdensity((wealth_t(:,15)+wealth_t(:,16)+wealth_t(:,17))/3);
[wealth_distr4446,xixi4446,bw4446]=ksdensity((wealth_t(:,18)+wealth_t(:,19)+wealth_t(:,20))/3);
[wealth_distr4749,xixi4749,bw4749]=ksdensity((wealth_t(:,21)+wealth_t(:,22)+wealth_t(:,23))/3);
[wealth_distr5052,xixi5052,bw5052]=ksdensity((wealth_t(:,24)+wealth_t(:,25)+wealth_t(:,26))/3);
[wealth_distr5355,xixi5355,bw5355]=ksdensity((wealth_t(:,27)+wealth_t(:,28)+wealth_t(:,29))/3);


%% SCF data

dataSCF=importdata('DensitiesSCF.dat');

xasset3840=dataSCF.data(:,7);
xasset4143=dataSCF.data(:,9);
xasset4446=dataSCF.data(:,11);
xasset4749=dataSCF.data(:,13);
xasset5052=dataSCF.data(:,15);
xasset5355=dataSCF.data(:,17);

kdasset3840=dataSCF.data(:,8);
kdasset4143=dataSCF.data(:,10);
kdasset4446=dataSCF.data(:,12);
kdasset4749=dataSCF.data(:,14);
kdasset5052=dataSCF.data(:,16);
kdasset5355=dataSCF.data(:,18);


%% Figure

figure('PaperPosition',[0.5 20 17 9.5])

subplot(1,2,1)
hold on;
plot(xixi3840,wealth_distr3840,'-k','linewidth',1)
plot(xixi4143,wealth_distr4143,'.-k','linewidth',1)
plot(xixi4446,wealth_distr4446,'-.k','linewidth',1)
plot(xixi4749,wealth_distr4749,'--k','linewidth',1)
plot(xixi5052,wealth_distr5052,':k','linewidth',1)
plot(xixi5355,wealth_distr5355,'.:k','linewidth',1)
hold off;
axis([1 5 0 1.3])
xticks([1 2 3 4 5])
yticks([0 0.2 .4 0.6 0.8 1 1.2])
title('Model','FontSize',11,'Interpreter','latex')
xlabel('Wealth','FontSize',11,'Interpreter','latex')
ylabel('Kernel Density','FontSize',11,'Interpreter','latex')
legend({'Age 38-40','Age 41-43','Age 44-46','Age 47-49','Age 50-52','Age 53-55'},'FontSize',10,'Interpreter','latex','Location','northeast')
 
subplot(1,2,2)
hold on;
plot(xasset3840,kdasset3840,'-k','linewidth',1)
plot(xasset4143,kdasset4143,'.-k','linewidth',1)
plot(xasset4446,kdasset4446,'-.k','linewidth',1)
plot(xasset4749,kdasset4749,'--k','linewidth',1)
plot(xasset5052,kdasset5052,':k','linewidth',1)
plot(xasset5355,kdasset5355,'.:k','linewidth',1)
hold off;
axis([0.5 3 0 1.3])
xticks([0.5 1 1.5 2 2.5 3])
yticks([0 0.2 0.4 0.6 0.8 1 1.2])
title('Data','FontSize',11,'Interpreter','latex')
xlabel('Wealth','FontSize',11,'Interpreter','latex')
ylabel('Kernel Density','FontSize',11,'Interpreter','latex')


print('Fig_8_distr','-dpdf')

