
clear;
clc;
   
global x_grid z_grid x_n z_n b_max q_max part bprime_n bprime_p qprime_n qprime_p sprime_p


%% Load Model Solution

load Model_1_PolFun.mat


%% Additional Parameters

I=500000; % number of simulations


%% Variable Initialisation

c_t=zeros(I,J);
x_t=zeros(I,J);
z_t=zeros(I,J);
b_t=zeros(I,J);
q_t=zeros(I,J);
s_t=zeros(I,J);
b_share_t=zeros(I,J);
q_share_t=zeros(I,J);
s_share_t=zeros(I,J);
part_t=zeros(I,J);


%% Exogenous Processes

rng('default')

U_t=zeros(I,J_ret);
U_t_ind=ones(I,J_ret);
U_t=U_t+U(1);
randnums=rand(I,J_ret);
highind=find(randnums>=0.5);
U_t_ind(highind)=2;
U_t(highind)=U(2);

N_t=zeros(I,J_ret);
N_t_ind=ones(I,J_ret);
N_t=N_t+N(1);
randnums=rand(I,J_ret);
highind=find(randnums>=0.5);
N_t_ind(highind)=2;
N_t(highind)=N(2);

Rs_t=zeros(I,J);
Rs_t_ind=ones(I,J);
Rs_t=Rs_t+Rs(1);
randnums=rand(I,J);
highind=find(randnums>=0.5);
Rs_t_ind(highind)=2;
Rs_t(highind)=Rs(2);

Rq_t=zeros(I,J);
Rq_t_ind=ones(I,J);
Rq_t(:,1)=Rq(1);
Rq_t_ind(:,1)=1;
randnums=rand(I,J);

for ii=1:I
for jj=2:J
    if Rq_t(ii,jj-1)==Rq(1)
        if randnums(ii,jj)<ProbRq(1,1)
            Rq_t(ii,jj)=Rq(1);
        else
            Rq_t(ii,jj)=Rq(2);
            Rq_t_ind(ii,jj)=2;
        end
    else
        if randnums(ii,jj)<ProbRq(2,1)
            Rq_t(ii,jj)=Rq(1);
        else
            Rq_t(ii,jj)=Rq(2);
            Rq_t_ind(ii,jj)=2;
        end
    end
end
end

clearvars randnums highfind


%% Simulation

x_t(:,1)=1.5; % initial value of liquid assets
z_t(:,1)=0; % initial values of illiquid assets
z_t(0.5*I:I,1)=0.25;


for jj=1:J-1
    jj
    
    
    bprime_Rqlow_j=zeros(x_n,z_n);
    qprime_Rqlow_j=zeros(x_n,z_n);
    sprime_Rqlow_j=zeros(x_n,z_n);
        
    bprime_Rqhigh_j=zeros(x_n,z_n);
    qprime_Rqhigh_j=zeros(x_n,z_n);
    sprime_Rqhigh_j=zeros(x_n,z_n);
    
    part_Rqlow_j=reshape(part(1:x_n*z_n,jj),z_n,x_n)';
    part_Rqhigh_j=reshape(part(x_n*z_n+1:end,jj),z_n,x_n)';
      
    age=jj+26;
    
    for z=1:z_n
        
        Pol_Fun_Rqlow=Prep_Fun(age,z,1);
        bprime_Rqlow_j(:,z)=Pol_Fun_Rqlow(:,1);
        qprime_Rqlow_j(:,z)=Pol_Fun_Rqlow(:,2);
        sprime_Rqlow_j(:,z)=Pol_Fun_Rqlow(:,3);
        part_help=find(part_Rqlow_j(:,z)==1,1);    
        part_Rqlow_j(part_help:end,z)=1;
        
        Pol_Fun_Rqhigh=Prep_Fun(age,z,2);
        bprime_Rqhigh_j(:,z)=Pol_Fun_Rqhigh(:,1);
        qprime_Rqhigh_j(:,z)=Pol_Fun_Rqhigh(:,2);
        sprime_Rqhigh_j(:,z)=Pol_Fun_Rqhigh(:,3);
        part_help=find(part_Rqhigh_j(:,z)==1,1);    
        part_Rqhigh_j(part_help:end,z)=1; 

    end
    
    
    for ii=1:I
    
        [~,x_t_ind]=min(abs(x_t(ii,jj)-x_grid));
        [~,z_t_ind]=min(abs(z_t(ii,jj)-z_grid));
     
        if Rq_t(ii,jj)==Rq(1)
            b_t(ii,jj)=bprime_Rqlow_j(x_t_ind,z_t_ind);
            q_t(ii,jj)=qprime_Rqlow_j(x_t_ind,z_t_ind);
            s_t(ii,jj)=sprime_Rqlow_j(x_t_ind,z_t_ind);
            part_t(ii,jj)=part_Rqlow_j(x_t_ind,z_t_ind);
        else
            b_t(ii,jj)=bprime_Rqhigh_j(x_t_ind,z_t_ind);
            q_t(ii,jj)=qprime_Rqhigh_j(x_t_ind,z_t_ind);
            s_t(ii,jj)=sprime_Rqhigh_j(x_t_ind,z_t_ind);
            part_t(ii,jj)=part_Rqhigh_j(x_t_ind,z_t_ind);
        end
        
        
        if jj<J_ret
            x_t(ii,jj+1)=(Rs_t(ii,jj+1)*s_t(ii,jj)+Rb*b_t(ii,jj)+delta*Rq_t(ii,jj+1)*q_t(ii,jj))/(G*N_t(ii,jj+1))+U_t(ii,jj+1);
            z_t(ii,jj+1)=((1-delta)*Rq_t(ii,jj+1)*q_t(ii,jj))/(G*N_t(ii,jj+1));
        elseif jj>=J_ret && jj<J  
            x_t(ii,jj+1)=(Rs_t(ii,jj+1)*s_t(ii,jj)+Rb*b_t(ii,jj)+delta*Rq_t(ii,jj+1)*q_t(ii,jj))/(G_ret*mean(N))+ret*mean(U);
            z_t(ii,jj+1)=((1-delta)*Rq_t(ii,jj+1)*q_t(ii,jj))/(G_ret*mean(N));       
        end
        
           
        b_share_t(ii,jj)=b_t(ii,jj)/(b_t(ii,jj)+q_t(ii,jj)+s_t(ii,jj));
        q_share_t(ii,jj)=q_t(ii,jj)/(b_t(ii,jj)+q_t(ii,jj)+s_t(ii,jj));
        s_share_t(ii,jj)=s_t(ii,jj)/(b_t(ii,jj)+q_t(ii,jj)+s_t(ii,jj));
    
    end
end

part_mean=mean(part_t);
nopart_ind=find(part_t==0);
q_share_condpart_t=q_share_t;
s_share_condpart_t=s_share_t;
b_share_condpart_t=b_share_t;
q_share_condpart_t(nopart_ind)=NaN;
s_share_condpart_t(nopart_ind)=NaN;
b_share_condpart_t(nopart_ind)=NaN;
q_share_condpart_mean=nanmean(q_share_condpart_t);
s_share_condpart_mean=nanmean(s_share_condpart_t);
b_share_condpart_mean=nanmean(b_share_condpart_t);


save Model_2_Simulation.mat I J part_mean b_share_condpart_mean q_share_condpart_mean s_share_condpart_mean x_t z_t


