
function F = interp2_lin(x,z,x_coord,z_coord,x_grid,z_grid,V)

% input

% x         b_n*q_n*s_n*nN*nU*nRs by 1 vector of x-values of points to be interpolated
% z         b_n*q_n*s_n*nN*nU*nRs by 1 vector of y-values of points to be interpolated
% x_coord   b_n*q_n*s_n*nN*nU*nRs by 1 vector of coordinates of next LOWER point on x grid
% z_coord   b_n*q_n*s_n*nN*nU*nRs by 1 vector of coordinates of next LOWER point on z grid
% x_grid    x_n by 1 vector giving x-grid
% z_grid    z_n by 1 vector giving z-grid
% V         x_n by z_n matrix given function values at each grid point
 

% output

% F         b_n*q_n*s_n*nN*nU*nRs by 1 vector of V-values belonging to each x-z pair


x0=x_grid(x_coord);
x1=x_grid(x_coord+1);
z0=z_grid(z_coord);
z1=z_grid(z_coord+1);

x2=x;
z2=z;

index=sub2ind(size(V),x_coord,z_coord+1);
V0=V(index);

index=sub2ind(size(V),x_coord+1,z_coord+1);
V1=V(index);

index=sub2ind(size(V),x_coord,z_coord);
V2=V(index);

index=sub2ind(size(V),x_coord+1,z_coord);
V3=V(index);


F=1./((x1-x0).*(z1-z0)).*((x1-x2).*(z2-z0).*V0+(x2-x0).*(z2-z0).*V1+(x1-x2).*(z1-z2).*V2+(x2-x0).*(z1-z2).*V3);


end